/*
Copyright (C) 2014 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/* data format t=type dat=DataAndType life2.jsѿ
"a yyyymmddthhmm val" (add) 
"d transactionKey yyyymmddthhmm val" (delete)
"c transactionKey yyyymmddthhmm val" (change) */

function DataAndTransaction(category, initAddr2Param) {
  this.data = new Data()
  this.tr = new Transaction(category)
  this.init(initAddr2Param)
}

DataAndTransaction.prototype.init = function(initAddr2Param) {
  this.data.removeAll()
  var keyList = this.tr.keyList(), i, key, val
  for(i = 0; i < keyList.length; i++){
    key = keyList[i]
    val = this.tr.get(key)
    switch(val.charAt(0)){
    case 'a':
      this.data.set(val.substr(2, 13), val.substr(16), key)
      break
    case 'd': {
      var i1 = val.indexOf(" ", 2), k1 = val.substring(2, i1)
      this.data.del(k1)
    } break
    case 'c': {
      var i1 = val.indexOf(" ", 2), k1 = val.substring(2, i1)
      this.data.del(k1)
      this.data.set(val.substr(i1 +1, 13), val.substr(i1 +1 +13 +1), key)
    } break
    }
  }
  var a = initAddr2Param
  this.data.initAddr2(a[0], a[1], a[2])
}

DataAndTransaction.prototype.trSetFromDb = function(key, val) {
  return this.tr.setFromDb(key, val)
}

DataAndTransaction.prototype.add = function(date, type, val) {
  this.set('a', date, type, val, null)
}

DataAndTransaction.prototype.change = function(date, type, val, key) {
  this.set('c', date, type, val, key)
}

DataAndTransaction.prototype.del = function(date, type, val, key) {
  this.set('d', date, type, val, key)
}

DataAndTransaction.prototype.set = function(setType, date, type, val, key) {
  if(date.match(/^\d{12}$/) == null){
    alert("DataAndTransaction: date error " + date)
    return
  }
  if(type < 0 || type > 9){
    alert("DataAndTransaction: type error " + type)
    return
  }
  var dat = date.substr(0, 8) + type + date.substr(8, 4)
  switch(setType){
  case 'a': {
    var trVal = "a " + dat + " " + val
    var trKey = this.tr.set(trVal)
    if(trKey != "")
      this.data.set(dat, val, trKey)
  } break
  case 'c': {
    var trVal = "c " + key + " " + dat + " " + val
    var trKey = this.tr.set(trVal)
    if(trKey != ""){
      this.data.set(dat, val, trKey)
      this.data.del(key)
    }
  } break
  case 'd': {
    var trVal = "d " + key + " " + dat + " " + val
    var trKey = this.tr.set(trVal)
    if(trKey != "")
      this.data.del(key)
  } break
  }
}

DataAndTransaction.prototype.get = function(date) {
  var dat = date.substr(0, 8) + "0" + date.substr(8, 4) // t=0ˤƤΤǡƤ˥ҥåȡ
  return this.getByType(dat, life2DataGetTypeDate)
}

DataAndTransaction.prototype.getByType = function(str, type) {
  switch(type){
  case life2DataGetTypeOneDay:
    return this.data.get(str.substr(0, 8) + "0" + str.substr(8, 4), type)
  }
  return this.data.get(str, type)
}

DataAndTransaction.prototype.dataGetFromTrKey = function(trKey) {
  return this.data.getFromTrKey(trKey)
}

DataAndTransaction.prototype.trKeyList = function() {
  return this.tr.keyList()
}

DataAndTransaction.prototype.trGet = function(key) {
  return this.tr.get(key)
}

DataAndTransaction.prototype.daCheckUpdate = function() {
  return this.data.checkUpdate()
}

// иٽ
DataAndTransaction.prototype.trGetBookItemList = function(index) {
  var h = [], ka = this.tr.keyList(), typeBook = "" + life2TypeBook, i
  for(i = 0; i < ka.length; i++){
    var tv = this.getTypeVal(this.tr.get(ka[i])), type = tv[0], val = tv[1]
    if(type != typeBook) continue
    var a = val.split(",")[index]
    if(a == "") continue
    if(a in h) h[a] += 1
    else h[a] = 0
  }
  var ret = [], k
  for(k in h)
    ret.push([h[k], k])
  return ret.sort(function(a, b) {
    var c = b[0] - a[0]
    if(c != 0) return c
    if(a[1] < b[1]) return -1
    else if(a[1] > b[1]) return 1
    return 0
  } )
}

// 
DataAndTransaction.prototype.trGetBookItemList2 = function(index) {
  var ret = [], ka = this.tr.keyList(), typeBook = "" + life2TypeBook, i
  for(i = 0; i < ka.length; i++){
    var dv = this.getDatVal(this.tr.get(ka[i])), dat = dv[0], val = dv[1]
    if(dat.substr(8, 1) != typeBook) continue
    var a = val.split(",")[index]
    if(a == "") continue
    ret.push([dat, a])
  }
  return ret.sort(function(a, b) {
    var c = b[0] - a[0]
    if(c != 0) return c
    if(a[1] < b[1]) return -1
    else if(a[1] > b[1]) return 1
    return 0
  } )
}

DataAndTransaction.prototype.getDatVal = function(v) {
  var dat = "", val = "", i = -1
  switch(v.charAt(0)){
  case 'a':
    dat = v.substr(2, 13)
    val = v.substr(16)
    break
  case 'c':
    i = v.indexOf(" ", 2)
    dat = v.substr(i +1, 13)
    val = v.substr(i +15)
    break
  }
  return [dat, val]
}

DataAndTransaction.prototype.getTypeVal = function(v) {
  var type = "", val = "", i = -1
  switch(v.charAt(0)){
  case 'a':
    type = v.substr(10, 1)
    val = v.substr(16)
    break
  case 'c':
    i = v.indexOf(" ", 2)
    type = v.substr(i +9, 1)
    val = v.substr(i +15)
    break
  }
  return [type, val]
}

DataAndTransaction.prototype.removeAll = function() {
  this.data.removeAll()
  this.tr.removeAll()
}

DataAndTransaction.prototype.trGetShukujitsu = function() {
  var ka = this.tr.keyList().reverse(), a = "" + life2TypeMente, i
  for(i = 0; i < ka.length; i++){
    var tv = this.getTypeVal(this.tr.get(ka[i])), type = tv[0], val = tv[1]
    if(type == a){
      var va = val.split("\n")
      if(va[0] == life2MenteShukujitsu){
        va.shift()
        return va.join(" ")
      }
    }
  }
  return ""
}

DataAndTransaction.prototype.trSetShukujitsu = function(date, s) {
  var ka = this.tr.keyList().reverse(), a = "" + life2TypeMente, key = "", i
  for(i = 0; i < ka.length; i++){
    var tv = this.getTypeVal(this.tr.get(ka[i])), type = tv[0]
    if(type == a){
      key = ka[i]
      break
    }
  }
  if(key == "")
    this.add(date, life2TypeMente, life2MenteShukujitsu + "\n" + s)
  else
    this.change(date, life2TypeMente, life2MenteShukujitsu + "\n" + s, key)
  return
}

DataAndTransaction.prototype.daGetMemo2 = function() {
  return this.data.getMemo2()
}

DataAndTransaction.prototype.setAddr2 = function(date, type, data, sep, del) {
  if(data == "")
    return "ǡǤ"
  var a = data.split(sep), i
  for(i = 0; i < a.length; i++){
    var b = a[i]
    if(!b.match(/^.+\n.+\n.+/))
      return "ɤ()̾()Ȥ񼰤ǤϤޤ"
    if(b.indexOf(del) == 0)
      return "ɤߥեɤƬˡ" + del + "פȤʸͭޤ"
  }
  return this. setAddr2Sub(date, type, data, sep, del)
}

DataAndTransaction.prototype.setAddr2Sub = function(date, type, data, sep, del) {
  var dat = date.substr(0, 8) + type + date.substr(8, 4)
  var trVal = "a " + dat + " " + data
  var trKey = this.tr.set(trVal)
  if(trKey == "")
    return "ǡϿǥ顼ȯޤ"
  this.data.set(dat, data, trKey)
  this.data.initAddr2(type, sep, del)
  return null
}

DataAndTransaction.prototype.daGetAddr2 = function() {
  return this.data.getAddr2()
}

DataAndTransaction.prototype.delAddr2 = function(date, type, val, sep, del) {
  return this.setAddr2Sub(date, type, del + val, sep, del)
}
