/*
Copyright (C) 2014 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
function UiNumSet(v) { life2UiNum._set(v) }

function UiNum(_obj) {
  this.obj = _obj
  this.data = ""
  this.func = null
}

UiNum.prototype.view = function(val, func) {
  if(val.match(/^-?\d+$/) == null) val = ""
  this.data = val
  this.func = func
  var s = this._view()
  this.obj.innerHTML = s
}

UiNum.prototype.get = function() {
  return this.data
}

UiNum.prototype._view = function() {
  var i
  var s = "<pre>"
  s += "<button onClick=\"UiNumSet(-3)\"></button>"
  s += "<button class=\"ui\" onClick=\"UiNumSet(-4)\"></button>"
  s += "<button class=\"ui\" onClick=\"UiNumSet(-7)\"></button>"
  s += "<button class=\"ui\" onClick=\"UiNumSet(-2)\"></button>\n"
  s += "<button class=\"ui\" onClick=\"UiNumSet(0)\">0</button>"
  s += "<span id=\"uiNum\">" + this.data + "</span>\n"
  for(i = 1; i <= 9; i++){
    s += "<button class=\"ui\" onClick=\"UiNumSet(" + i + ")\">" + i + "</button>"
    if(i == 3) s += "<button class=\"ui\" onClick=\"UiNumSet(-6)\">+1</button>\n"
    if(i == 6) s += "<button class=\"ui\" onClick=\"UiNumSet(-5)\">-1</button>\n"
    if(i == 9) s += "\n"
  }
  s += "<button class=\"ui\" onClick=\"UiNumSet(-8)\">00</button>"
  s += "<button class=\"ui\" onClick=\"UiNumSet(-9)\">000</button>"
  s += "<button class=\"ui\" onClick=\"UiNumSet(-1)\">-</button>"
  return s
}
  
UiNum.prototype._set = function(v) {
  if(v >= 0 && v <= 9){
    this.data += "" + v
  }else{
    switch(v){
    case -1:
      if(this.data.charAt(0) == '-'){
        this.data = this.data.substr(1)
      }else{
        this.data = "-" + this.data
      }
      break
    case -2:
      if(this.data != "")
        this.data = this.data.substr(0, this.data.length -1)
      break
    case -3:
      this.func()
      return
    case -4:
      this.data = ""
      break
    case -5: {
      var n = parseInt(this.data)
      n--
      this.data = "" + n
    } break
    case -6: {
      var n = parseInt(this.data)
      n++
      this.data = "" + n
    } break
    case -7:
      if(this.data != "")
        this.data = this.data.substr(1)
      break
    case -8:
      this.data += "00"
      break
    case -9:
      this.data += "000"
      break
    }
  }
  document.getElementById("uiNum").textContent = this.data
}
